/*
	Phoenix Suite 2
	Author: Jean-Baptiste Wautier
	Copyright 2006-2009 (c)
*/
﻿namespace Phoenix.Log.Writer
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Gives instance on a logger.
    /// </summary>
    public static class LogManager
    {
        #region Fields

        private static ILogger logger;

        #endregion Fields

        #region Methods

        /// <summary>
        /// Configures the specified configurator.
        /// </summary>
        /// <param name="configurator">The configurator.</param>
        public static void Configure(IConfigurator configurator)
        {
            logger = configurator.GetLogger(typeof(LogManager));
        }

        /// <summary>
        /// Gets an instance of the logger.
        /// </summary>
        /// <param name="typeOfSender">The typeof sender.</param>
        /// <returns></returns>
        public static ILogger GetLogger(Type typeOfSender)
        {
            if (logger == null)
                throw new ArgumentNullException("typeOfSender", "Impossible to instanciate the logger. Did you forget to configure the logger?");
            logger.SetTypeOfSender(typeOfSender);
            return logger;
        }

        #endregion Methods
    }
}